
//////////////////////////// RCS COMMENTS: /////////////////////////////
//
//  This is a stub program for the sake of
//  testing the star library.
//
//  It simply creates a copy of the data and prints it.
//
// $Log: copy.cc,v $
// Revision 2.0  1999/01/23  03:35:34  madings
// Since this new version compiles on
// multiple platforms(well, okay, 2 of them), I
// thought it warranted to call it version 2.0
//
// Revision 1.2  1999/01/22  23:58:42  madings
// Golly, where should I begin?  Okay, There was a port to linux being
// done in this version, which in turn meant a port to egcs instead of
// making code that can only compile on a CFront style compiler like SGI
// uses.  This port meant a lot of tiny changes all over the place to
// accomodate the differences in the way templates get linked.  Also,
// a bug was discovered in the way rows were deleted in the LoopTableNode's
// erase() operator.  The bug was there all along and it surfaced as part
// of the portation (what was just bad data in SGI was causing coredumps
// in Linux.)  Hopefully now that it compiles under egcs, it will be much
// more portable and I can begin getting it out to the public.
//
// Revision 1.1  1998/09/04  20:57:27  madings
// Added the examples.
//
//
////////////////////////////////////////////////////////////////////////

#include "portability.h"
#include <unistd.h>
#include <stdio.h>
#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include "ast.h"
#include "parser.h"

// GLOBAL variable: the root of the AST built by a (successful) parse)
StarFileNode *AST;

// output stream:
ofstream * os;

// For printing a string when debugging.  If the C++ string lib
// was not compiled with debug on, then you must call this
// function from the debugger prompt to see the string's contents:
void gdb_str( string const &s )
{
    cout << "len: " << s.length() << "Contents: \"" << s << "\"" << endl;
}

  ///////////////////
 //    main()     //
///////////////////
int main( int argc, char **argv )
{

    StarFileNode   *newCopy;
    // make the star input/output be stdin and stdout:
    // -----------------------------------------------
    os = new ofstream( fileno(stdout) );  // output
    yyin = stdin; // input

    if (yyparse() == 0)   // returns nonzero on error
    {
	// Make a copy of it:
	newCopy = new StarFileNode( true, *AST );

	(*os) << "============================" << endl 
	      << "============================" << endl
	      << "===  Original Version ======" << endl
	      << "============================" << endl
	      << "============================" << endl;

	AST->Unparse(0);

	(*os) << "============================" << endl 
	      << "============================" << endl
	      << "===  Copy Of Original ======" << endl
	      << "== (should be identical) ===" << endl
	      << "============================" << endl;
	newCopy->Unparse(0);

	delete AST;
	delete newCopy;
    }
    else
        cerr << "# Error: Parsing problems in source file"<<endl;


    delete os; // Must do this to close the output, else it never flushes
               // the last line of output.

    return 0;
}
